<?php
/**
 * sample code for GiroCheckout integration of a iDEAL Refund transaction
 *
 * Call from command line in two steps:
 * 1) Without arguments for initial SALE transaction: php IdealRefund.php
 * 2) With reference code from SALE for REFUND: php IdealRefund.php 43290-48329043-43289
 * 
 * @filesource
 * @package Samples
 * @version $Revision: 138 $ / $Date: 2016-04-27 12:23:07 -0300 (Mi, 27 Apr 2016) $
 */
require_once '../../GiroCheckout_SDK/GiroCheckout_SDK.php';

/**
 * configuration of the merchants identifier, project and password
 * this information can be found in the GiroCockpit's project settings
 */
$merchantID = 350000;
$projectID = 7288;
$projectPassword = "VocZhr8WAXsu";

$strReference = "";

if( $argc == 1 ) {
  /* STEP 1: init iDEAL SALE transaction and parameters */
  try {
    $request = new GiroCheckout_SDK_Request('idealPayment');
    $request->setSecret($projectPassword);
    $request->addParam('merchantId',$merchantID)
        ->addParam('projectId',$projectID)
        ->addParam('merchantTxId',1234567890)
        ->addParam('amount',100)
        ->addParam('currency','EUR')
        ->addParam('purpose','iDEAL Zahlung')
        ->addParam('urlRedirect','https://www.my-domain.de/girocheckout/redirect-ideal')
        ->addParam('urlNotify','https://www.my-domain.de/girocheckout/notify-ideal')
        ->addParam('issuer','RABOBANK')
        //the hash field is auto generated by the SDK
        ->submit();

    print_r($request->getResponseRaw());
    echo "\n";

    // if request succeeded get the issuer list
    if($request->requestHasSucceeded()) {
      $strReference = $request->getResponseParam('reference');
      echo "Reference obtained: $strReference\n";
      $request->getResponseParam('redirect');

      //$request->redirectCustomerToPaymentProvider();
    }

    // if the request did not succeed, get the responsecode and notify the customer
    else {
      $request->getResponseParam('rc');
      $request->getResponseParam('msg');
      $request->getResponseMessage($request->getResponseParam('rc'),'DE');
    }
  }
  catch (Exception $e) { echo $e->getMessage(); }
}
else {
  // STEP 2: REFUND
  $strReference = $argv[1];

  if( !empty($strReference) ) {
    echo "\nOrig Trx Ref: $strReference\n";

    // init giropay transaction and parameters
    try {  
      $request = new GiroCheckout_SDK_Request('idealRefund');
      $request->setSecret($projectPassword);
      $request->addParam('merchantId',$merchantID)
              ->addParam('projectId',$projectID)
              ->addParam('merchantTxId',"123456")
              ->addParam('amount',100)  // Anzahlung
              ->addParam('currency','EUR')
              ->addParam('reference', $strReference)

              //the hash field is auto generated by the SDK
              ->submit();

      print_r($request->getResponseRaw());
      echo "\n";

      // if transaction succeeded update your local system an redirect the customer 
      if($request->requestHasSucceeded()) {
        $request->getResponseParam('rc');
        $request->getResponseParam('msg');
        $request->getResponseParam('reference');
        $request->getResponseParam('redirect');

        $request->redirectCustomerToPaymentProvider();
      }

      // if the transaction did not succeed update your local system, get the responsecode and notify the customer
      else {
        $request->getResponseParam('rc');
        $request->getResponseParam('msg');
        $request->getResponseMessage($request->getResponseParam('rc'),'DE');
      }
    }
    catch (Exception $e) { echo $e->getMessage(); }
  }
}
